; 65c816 opcodes 0xC0-0xCF:
;    C0: CPY #       2,2
;    C1: CMP (d,x)   2,6
;    C2: REP #       2,3
;    C3: CMP d,s     2,4
;    C4: CPY d       2,3
;    C5: CMP d       2,3
;    C6: DEC d       2,5
;    C7: CMP [d]     2,6
;    C8: INY i       1,2
;    C9: CMP #       2,2
;    CA: DEX i       1,2
;    CB: WAI i       1,3
;    CC: CPY a       3,4
;    CD: CMP a       3,4
;    CE: DEC a       3,6
;    CF: CMP al      4,5

; C0
EX_CPY i,Immediate
E0_CPY i,Immediate

; C1
EM_CMP Od_xO,Direct_Indexed_Indirect
E0_CMP Od_xO,Direct_Indexed_Indirect

; C2

ALIGNC
E0_REP:
 E0_SETUPFLAGS
 mov ah,[1+R_NativePC]
 xor ah,0xFF
 and al,ah
 E0_RESTOREFLAGS

 add R_NativePC,byte 2

 JUMP_FLAG SNES_FLAG_I,.no_irq
 mov al,[IRQ_pin]
 test al,al
 jz .no_irq
 SAVE_PC ebx
 add R_Cycles,byte 60   ; IRQ processing: 2 IO + 6 bank0
 call E0_IRQ
 LOAD_PC
.no_irq:
 SET_TABLE_MX

ALIGNC
E1_REP:
 E1_SETUPFLAGS
 mov ah,[1+R_NativePC]
 xor ah,0xFF
 and al,ah
 or al,0x30
 E1_RESTOREFLAGS

 add R_NativePC,byte 2

 JUMP_FLAG SNES_FLAG_I,CPU_RETURN,near
 mov al,[IRQ_pin]
 test al,al
 jz near CPU_RETURN
 SAVE_PC ebx
 add R_Cycles,byte 52   ; IRQ processing: 2 IO + 5 bank0
 call E1_IRQ
 LOAD_PC
 jmp near CPU_RETURN

; C3
EM_CMP d_s,Stack_Relative
E0_CMP d_s,Stack_Relative

; C4
EX_CPY d,Direct
E0_CPY d,Direct

; C5
EM_CMP d,Direct
E0_CMP d,Direct

; C6
EM_DEC d,Direct
E0_DEC d,Direct

; C7
EM_CMP IdI,Direct_Indirect_Long
E0_CMP IdI,Direct_Indirect_Long

; C8

ALIGNC
EX_INY:
 inc R_NativePC
 inc byte B_Y
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E0_INY:
 inc R_NativePC
 inc word B_Y
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; C9
EM_CMP i,Immediate
E0_CMP i,Immediate

; CA

ALIGNC
EX_DEX:
 inc R_NativePC
 dec byte B_X
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E0_DEX:
 inc R_NativePC
 dec word B_X
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; CB

ALIGNC
ALL_WAI:            ; Wait for interrupt
 mov al,[IRQ_pin]
 test al,al
 jnz .irq_active
 mov eax,[_EventTrip]
 mov byte [In_WAI],-1
 cmp eax,R_Cycles
 js near CPU_RETURN
 mov R_Cycles,eax
 jmp near CPU_RETURN
ALIGNC
.irq_active:
 inc R_NativePC
 jmp near CPU_RETURN

; CC
EX_CPY a,Absolute
E0_CPY a,Absolute

; CD
EM_CMP a,Absolute
E0_CMP a,Absolute

; CE
EM_DEC a,Absolute
E0_DEC a,Absolute

; CF
EM_CMP al,Absolute_Long
E0_CMP al,Absolute_Long
