#ifndef SNEeSe_helper_h
#define SNEeSe_helper_h

#include "misc.h"

EXTERN unsigned
 KEY_UP_1,KEY_DOWN_1,KEY_LEFT_1,KEY_RIGHT_1,
 KEY_A_1,KEY_B_1,KEY_X_1,KEY_Y_1,
 KEY_L_1,KEY_R_1,KEY_SELECT_1,KEY_START_1,
 KEY_UP_2,KEY_DOWN_2,KEY_LEFT_2,KEY_RIGHT_2,
 KEY_A_2,KEY_B_2,KEY_X_2,KEY_Y_2,
 KEY_L_2,KEY_R_2,KEY_SELECT_2,KEY_START_2;

EXTERN unsigned char WRAM[131072];  /* Buffer for Work RAM */
EXTERN unsigned char VRAM[65536];   /* Buffer for Video RAM */
EXTERN unsigned char VRAM_DI[65536];/* Buffer for Video RAM (deinterleaved) */
EXTERN unsigned char SRAM[65536];   /* Buffer for Save RAM */
EXTERN unsigned char SPCRAM[65536]; /* Buffer for SPC RAM/ROM */
EXTERN unsigned char Blank[65536];  /* Blank ROM buffer */
EXTERN unsigned char OAM[512+32];   /* Buffer for OAM */

EXTERN unsigned short ScreenX,ScreenY;
EXTERN signed char MOUSE_PLUGGED_IN;

typedef struct {
 unsigned short blue  :5;
 unsigned short green :6;
 unsigned short red   :5;
} colorRGB565;

typedef struct {
 unsigned short red   :5;
 unsigned short green :5;
 unsigned short blue  :5;
 unsigned short fill  :1;
} colorBGR555;

EXTERN unsigned char MosaicLine[16][256];      /* Used for mosaic effect */
EXTERN unsigned char BrightnessAdjust[16][256];/* Used for brightness effect */
EXTERN RGB SNES_Palette[256];                  /* So I can access from cc modules! */
EXTERN colorBGR555 Real_SNES_Palette[256];     /* Updated by palette write */
EXTERN colorRGB565 HICOLOUR_Palette[256][2];   /* values in here are plotted direct to PC! */

EXTERN void SetupTables(void);
EXTERN void Reset_CGRAM(void);
EXTERN void install_key_release_callback();

#ifdef DEBUG
EXTERN unsigned Frames;
EXTERN unsigned FrameLimit;
#endif

EXTERN unsigned M7X,M7Y,M7A,M7B,M7C,M7D;

EXTERN unsigned short PC_SCREEN_MODE;

EXTERN unsigned char *SNES_Screen;
EXTERN unsigned char *SNES_Screen8;

EXTERN BITMAP *Allegro_Bitmap;  /* Renamed (I'm using mostly allegro now so what the hell!) */
EXTERN BITMAP *Internal_Bitmap;
EXTERN BITMAP *Internal_Bitmap_blitsrc;

EXTERN unsigned FRAME_SKIP_MIN;     /* Min frames waited until refresh */
EXTERN unsigned FRAME_SKIP_MAX;     /* Max frames waited until refresh */
EXTERN unsigned char SNES_COUNTRY;  /* Used for PAL/NTSC protection checks */
EXTERN unsigned char JOYSTICK_ENABLED;
EXTERN unsigned char JOYSTICK_ENABLED2;
EXTERN unsigned char SPC_ENABLED;

EXTERN unsigned long VRamTop;

EXTERN unsigned short MickeyRead;   /* MSB = Yyyyyyyy  LSB = Xxxxxxxx */
EXTERN unsigned char MouseButts;

EXTERN void MickeyMouse(void);

EXTERN unsigned char BrightnessLevel;   /* SNES Brightness level, set up in PPU.asm */
EXTERN char fixedpalettecheck;

EXTERN void SetPalette(void);
EXTERN void CopySNESScreen(void);

/*EXTERN unsigned char S_A,S_X,S_Y;
EXTERN unsigned short S_S,S_PC,S_P;*/

#endif /* SNEeSe_helper_h */
